      /////////////////////////////////////////////////////////
     //Name: Pixel Grass Demo                               //
    //Discription: Generates clean grass that does not     //
   //              tile like most hand made grass icons.  //
  //Creator: Scoobert                                    //
 //Creation Date: 1/20/04                               //
/////////////////////////////////////////////////////////

//This demo is intended to be used on a games startup.
//Render your states when you first start hosting, no during gameplay.
//This system is very slow and would prevent gameplay from working if done
//   more than just at startup.
//It has also been suggested that you can use the ftp() proc to export the
//   generated icons into dmi files, then include them in your game.

#define States 5  //The number of Icons to make. I suggest 50 as max and 5 as minimum
world/New()//when the world starts
	gen=1//flip gen to 1 to keep someone from starting it while it is automaticly doing it.
	sleep(10)//wait a second
	world<<"Grenerating Grass;([States] icons to render)"//tell them whats happening
	var/N=States//set N to states, which is 5, in this case.
	while(N)//while there are states to generate
		var/icon/I=grassgen()//make a grass icon
		grassicons.Add(I)//add our new grass to the list of grass icons
		world<<".\c"//Show a dot, this is a basic loading bar
		N--//take away 1 from N, so the program nows when it is done.
		sleep(1)//wait .1 second, this is just to prevent dreamseeker from freezing.
	for(var/turf/grass/G in world)//for all the grass in the world
		G.icon=pick(grassicons)//pick an icon state and give it to the grass
	world<<"\n Grass Generating Done."//tell them that it is done.
	gen=0//unlock the gen commands
	..()
var/list/grassicons=new/list()//our list for grass.
var/gen//our var to prevent more than one person from generating icons at once.
turf/grass//basic grass turf
	icon='grass.dmi'//icon is grass.dmi
	icon_state="grass"//state is grass
mob/verb/regengrass(var/N as num)//this is the verb to call to start the renter proccess.
	if(N>50)//if N is greater than 50...
		return 0//...just screw it because 50 is too high to resonably render.
	if(gen==1)//check to see if something is already rendering.
		src<<"Currently Rendering Something"//tell them what I just said
	else//if nothing is rendering
		gen=1//set gen to true to prevent someone from starting another render proccess at the same time.
		world<<"Grenerating Grass;([N] icons to render)"//tell them how many are being rendered.
		del(grassicons)//clear out the current grass icons
		grassicons=new/list()//make the list again
		while(N)//while N is not 0
			var/icon/I=grassgen()//call the grass gen proc and save it to I
			grassicons.Add(I)//add I to the list.
			world<<".\c"//put a . and do not return to a new line
			N--//minus one from N
			sleep(1)//Wait .1 seconds to prevent DS from freezing
		for(var/turf/grass/G in world)//for all grass in the world.
			G.icon=pick(grassicons)//make it pick an icon from our grass list
		world<<"\n Grass Generating Done."//tell them that it has finished
		gen=0//set gen back to 0 so that it can be run again.
mob/verb/regenwater(var/N as num)
	if(N>50)
		return 0
	if(gen==1)
		src<<"Currently Rendering Something"
	else
		gen=1
		world<<"Grenerating Water;([N] icons to render)"
		del(grassicons)
		grassicons=new/list()
		while(N)
			var/icon/I=watergen()
			grassicons.Add(I)
			world<<".\c"
			N--
			sleep(1)
		for(var/turf/grass/G in world)
			G.icon=pick(grassicons)
		world<<"\n Water Generating Done."
		gen=0
mob/verb/say(var/txt as text)//pointless, generic say
	world<<"[usr]: [txt]"
proc
	grassgen()//the grass gen proc
		var/icon/I = new('grass.dmi')//blank icon
		for(var/x = 1, x<=32,x++)//for all that are in x, check if x is less than 32 then add one...I think
			for(var/y = 1, y<=32,y++)
				var/icon/temp = new('pixel.dmi')//icon with one pixel black in the very corner
				temp.SwapColor(rgb(0,0,0),rgb(0,rand(75,220),0))//swap the black with something simular to green
				temp.Shift(EAST,x-1)//move east 1
				temp.Shift(SOUTH,y-1)//move south 1
				I.Blend(temp,ICON_OVERLAY)//add temp to the main icon.
		adddirt(I)
		return I
	watergen()
		var/icon/I = new('grass.dmi')//blank icon
		for(var/x = 1, x<=32,x++)
			for(var/y = 1, y<=32,y++)
				var/icon/temp = new('pixel.dmi')//icon with one pixel black in the very corner
				temp.SwapColor(rgb(0,0,0),rgb(0,0,255-(rand(0,256))))
				temp.Shift(EAST,x-1)
				temp.Shift(SOUTH,y-1)
				I.Blend(temp,ICON_OVERLAY)
		return I
	adddirt(var/icon/I)
		for(var/x = 1, x<=32,x++)
			for(var/y = 1, y<=32,y++)
				if(prob(10))//1 in 10 chance of it happening. Prevents to much dirt
					var/icon/temp = new('pixel.dmi')//icon with one pixel black in the very corner
					temp.SwapColor(rgb(0,0,0),rgb(rand(110,150),rand(110,150),0))
					temp.Shift(EAST,x-1)
					temp.Shift(SOUTH,y-1)
					I.Blend(temp,ICON_OVERLAY)
		return I
mob
	icon='person.dmi'